/**
 * $Id: controller.h,v 1.3 2007/04/06 09:05:26 superkkt Exp $
 *
 * Connection Controller Thread Header
 *
 * Copyright 2007 Samjung Data Service, Inc.  All rights reserved.
 * 김기태 (superkkt@sds.co.kr)
 */

#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "pxe.h"
#include "support.h"

/*
 * Master Mode Arguments
 */
typedef struct
{
    int port;
} MasterControl;

/*
 * Agent Mode Arguments
 */
typedef struct
{
    char *alias;
    char ip[16];
    int port;
    int reconnect_delay;
} AgentControl;

void *master_controller(void *arg);
void *agent_controller(void *arg);

void set_dce(PXE_DCE idx);
PXE_DCE get_dce(void);

BOOL am_i_master(void);
BOOL is_localhost_ip(const unsigned char *ip);
BOOL is_master_ip(const unsigned char *ip);

#endif
