/**
 * $Id: support.h,v 1.5 2007/04/06 09:05:26 superkkt Exp $
 *
 * Support Functions Header
 *
 * Copyright 2007 Samjung Data Service, Inc.  All rights reserved.
 * 김기태 (superkkt@sds.co.kr)
 */

#ifndef SUPPORT_H
#define SUPPORT_H

#include <netdb.h>
#include <sys/socket.h>

#define	FREE(pointer)      do { free(pointer); (pointer) = NULL; } while (0)
#define ARRAY_SIZE(array)   sizeof(array) / sizeof((array)[0])

typedef enum 
{
    FALSE,
    TRUE
} BOOL;

/*
 * Network IO Wrapping Functions
 */
int Accept_wrap(int fd, struct sockaddr *sa, socklen_t *salenptr);
int Connect_wrap(const char *host, int port);
int socket_listen_wrap(int port);
ssize_t readn_wrap(int fd, void *vptr, size_t n);
ssize_t writen_wrap(int connfd, const void *buf, size_t len);

int set_ip(unsigned char *buf, const char *ip);
void get_ip(char *buf, size_t len, const unsigned char *ip);

#endif
